package de.hdm_stuttgart.mi.sd1.task1;

/**
 * Array helper methods.
 */
public class HelperArray {

    /**
     * <p>Filter an array of strings for creating a new array containing only those
     * non-<code>null</code> values following a given reference string. The arguments array is being untouched.</p>
     *
     * <p>Examples starting from the series of strings
     * <code>{"brown", "red", null, "yellow", "green"}</code>:</p>
     *
     <table class="goikTableDefaults">
     *   <tr>
     *     <th>Reference</th>
     *     <th colspan="2">Result</th>
     *   </tr>
     *
     *   <tr>
     *       <td><code>"magenta"</code></td>
     *       <td><code>{"red", "yellow"}</code></td>
     *       <td>Both <code>"brown"</code> and <code>"green"</code> precede "magenta" alphabetically and thus get
     *       evicted. The <code>null</code> value is being ignored.</td>
     *   </tr>
     *
     *   <tr>
     *       <td><code>"red"</code></td>
     *       <td><code>{"yellow"}</code></td>
     *       <td>All values except <code>{"yellow"}</code> precede <code>"red"</code>.</td>
     *   </tr>
     *
     * </table>
     *
     * <section class="implementationHints">
     *
     *     <h3>Implementation hint:</h3>
     *
     *     <ul>
     *         <li>See {@link String#compareTo(String)}.</li>
     *     </ul>
     *
     * </section>
     *
     * @param values {@link String} or <code>null</code> containing {@link String} and/or <code>null</code> values.
     * @param reference A reference string defining a filter.
     * @return A possibly empty array containing only those non-<code>null</code> values following the
     * reference string in alphabetical order. If either argument is <code>null</code> the result will be an empty array.
     */
    static public String[] getAlphabeticalFollowers(final String[] values, final String reference) {
      return null; // TODO:Implement me correctly
  }

  /**
   * <p>An element <strong>e</strong> of an integer array is called a leader if either of the following two
   * statements hold:</p>
   *
   * <ul>
   *   <li>
   *     <p><strong>e</strong> is larger than or equal to all of its right neighbours.</p>
   *   </li>
   *   <li>
   *     <p><strong>e</strong> has got no right neighbours i.e. is itself the last array element.</p>
   *     <p>Consequence: An array's rightmost element is always a leader.</p>
   *   </li>
   * </ul>
   *
   * <p>Example: The array <strong>[1, 4, -2, 0, 3]</strong> contains two leaders [4, 3] at array index positions
   * 1 and 4 respectively.</p>
   *
   * @param values A non-empty sequence of values.
   * @return An array containing all leader values including possible duplicates preserving their order of appearance
   * within the original array.
   */
  static public int[] getLeaders(final int[] values) {
      return null; // TODO:Implement me correctly
  }
}