package de.hdm_stuttgart.mi.sd1.test.task1;

import de.hdm_stuttgart.mi.exam.unitmarking.ExaminationTestDefaults;
import de.hdm_stuttgart.mi.sd1.task1._4_ArrayHelper;
import org.junit.Assert;
import org.junit.FixMethodOrder;
import org.junit.Test;
import org.junit.runners.MethodSorters;

@FixMethodOrder(MethodSorters.NAME_ASCENDING)
public class Test_4_ArrayHelper extends ExaminationTestDefaults {

    @Test
    public void test_100_Null() {
        Assert.assertArrayEquals(new int[]{}, _4_ArrayHelper.eliminate(null, 9));
    }
    @Test
    public void test_120_Empty() {
        Assert.assertArrayEquals(new int[]{}, _4_ArrayHelper.eliminate(new int[]{}, -4));
    }
    @Test
    public void test_160_one() {
        Assert.assertArrayEquals(new int[]{1}, _4_ArrayHelper.eliminate(new int[]{1}, -4));
        Assert.assertArrayEquals(new int[]{}, _4_ArrayHelper.eliminate(new int[]{3}, 3));
    }
    @Test
    public void test_180_two() {
        Assert.assertArrayEquals(new int[]{7, 8}, _4_ArrayHelper.eliminate(new int[]{7, 8}, -4));
        Assert.assertArrayEquals(new int[]{9}, _4_ArrayHelper.eliminate(new int[]{9, 5}, 5));
        Assert.assertArrayEquals(new int[]{9}, _4_ArrayHelper.eliminate(new int[]{5, 9}, 5));
        Assert.assertArrayEquals(new int[]{}, _4_ArrayHelper.eliminate(new int[]{-1, -1}, -1));
    }
    @Test
    public void test_200_LongSingle() {
        final int[] values = {1, 2, 3, 4, 5, 6, 7, 8, 9};
        Assert.assertArrayEquals(values, _4_ArrayHelper.eliminate(values, -4));
        Assert.assertArrayEquals(new int[]{2, 3, 4, 5, 6, 7, 8, 9}, _4_ArrayHelper.eliminate(values, 1));
        Assert.assertArrayEquals(new int[]{1, 3, 4, 5, 6, 7, 8, 9}, _4_ArrayHelper.eliminate(values, 2));
        Assert.assertArrayEquals(new int[]{1, 2, 4, 5, 6, 7, 8, 9}, _4_ArrayHelper.eliminate(values, 3));
        Assert.assertArrayEquals(new int[]{1, 2, 3, 5, 6, 7, 8, 9}, _4_ArrayHelper.eliminate(values, 4));
        Assert.assertArrayEquals(new int[]{1, 2, 3, 4, 6, 7, 8, 9}, _4_ArrayHelper.eliminate(values, 5));
        Assert.assertArrayEquals(new int[]{1, 2, 3, 4, 5, 7, 8, 9}, _4_ArrayHelper.eliminate(values, 6));
        Assert.assertArrayEquals(new int[]{1, 2, 3, 4, 5, 6, 8, 9}, _4_ArrayHelper.eliminate(values, 7));
        Assert.assertArrayEquals(new int[]{1, 2, 3, 4, 5, 6, 7, 9}, _4_ArrayHelper.eliminate(values, 8));
        Assert.assertArrayEquals(new int[]{1, 2, 3, 4, 5, 6, 7, 8}, _4_ArrayHelper.eliminate(values, 9));
    }
    @Test
    public void test_220_LongMultiple() {
        final int[] values = {1, 3, -4, 22, 5, 2, 5, 7, 1, 1};

        Assert.assertArrayEquals(values, _4_ArrayHelper.eliminate(values, -10));

        Assert.assertArrayEquals(new int[]{3, -4, 22, 5, 2, 5, 7},
                _4_ArrayHelper.eliminate(values, 1));

        Assert.assertArrayEquals(new int[]{1, -4, 22, 5, 2, 5, 7, 1, 1},
                _4_ArrayHelper.eliminate(values, 3));

        Assert.assertArrayEquals(new int[]{1, 3, 22, 5, 2, 5, 7, 1, 1},
                _4_ArrayHelper.eliminate(values, -4));

        Assert.assertArrayEquals(new int[]{1, 3, -4, 5, 2, 5, 7, 1, 1},
                _4_ArrayHelper.eliminate(values, 22));

        Assert.assertArrayEquals(new int[]{1, 3, -4, 22, 2, 7, 1, 1},
                _4_ArrayHelper.eliminate(values, 5));

        Assert.assertArrayEquals(new int[]{1, 3, -4, 22, 5, 5, 7, 1, 1},
                _4_ArrayHelper.eliminate(values, 2));

        Assert.assertArrayEquals(new int[]{1, 3, -4, 22, 5, 2, 5, 1, 1},
                _4_ArrayHelper.eliminate(values, 7));

        Assert.assertArrayEquals(new int[]{},
                _4_ArrayHelper.eliminate(new int[]{3, 3, 3, 3, 3, 3, 3, 3}, 3));
    }
}
